#!/usr/bin/python

import sys
import os
import datetime
import math

t0 = datetime.datetime.now()

#############################################################################################

def GetPathAndName(path_filename):
    list=path_filename.split('/')
    filename=list[len(list)-1]
    path=path_filename[0:len(path_filename)-len(filename)]
    return [path, filename]
       
def checklength(filename):
    n=0
    file=open(filename, 'r')
    read_length=len(file.readline().strip())
    file.close()
    return read_length

def checkindexlistFwd(ref,indexlist,range1,range2):
    resultlist=[]
    uplim=ref+range1
    lowlim=ref+range2+25
    for index in indexlist:
        if index<uplim and index>lowlim:
            resultlist.append(index)
    return resultlist

def checkindexlistRes(ref,indexlist,range1,range2):
    resultlist=[]
    lowlim=ref-range1
    uplim=ref-range2
    for index in indexlist:
        if index>lowlim and index <uplim:
            resultlist.append(index)
    return resultlist

def compleseq(seq):
    newseq=""
    for base in seq:
        if base=="A":
            base="T"
        elif base=="C":
            base="G"
        elif base=="G":
            base="C"
        elif base=="T":
            base="A"
        newseq=base+newseq
    return newseq

def directranslate(direc_type):
    direc_type=abs(direc_type)
    if direc_type==1:
        return "+"
    elif direc_type==2:
        return "-"

def rangedict(dict):
    range=max(dict)-min(dict)+1
    return range

def comparelist(list1, list2):
    i=0
    result=0
    for word in list1:
        if word!=list2[i]:
            result+=1
        i+=1
    return result

def combine_result_list(jun_list1,jun_list2):
    result=[]
    for result_jun1st in jun_list1:
        Indicator_exist=0
        for result_jun2nd in jun_list2:
            if comparelist(result_jun1st, result_jun2nd)==0:
                Indicator_exist=+1
        if Indicator_exist==0:
            result.append(result_jun1st)
    for result_jun2nd in jun_list2:
        result.append(result_jun2nd)
    return result

def checkgoodlists(good_list1st, good_list2nd):
    good_list={}
    for index in good_list1st:
        if good_list2nd.has_key(index):
            good_list[index]=combine_result_list(good_list1st[index],good_list2nd[index])
        else:
            good_list[index]=good_list1st[index]
    for index in good_list2nd:
        if not good_list1st.has_key(index):
            good_list[index]=good_list2nd[index]
    return good_list 

def cal_half_distance(length):
    result=20000
    if length>9 and length<16:
        result=20000
    elif length>15 and length <21:
        result=100000
    elif length>20:
        result=400000
    return result

def designsuffix(read_length):
    result=[]
    Nsegment=0
    if read_length==50:
        Nsegment=1
    elif read_length<=59:
        Nsegment=2
    else:
        Nsegment=math.floor((read_length-60)/30)+2
    Nsegment=int(Nsegment)

    result.append([1,50])
    i=1
    start_pt=1
    end_pt=50
    while i < Nsegment:
        distance=math.floor((read_length-50)/(Nsegment-i))
        start_pt=int(distance+start_pt)
        end_pt=int(distance+end_pt)
        result.append([start_pt,end_pt])
        read_length=read_length-distance
        i+=1
    return result

def make_onesegment_namelist(reads_name, read_length):
    result=[]
    segment_suffix_list=designsuffix(read_length)
    for segment_suffix in segment_suffix_list:
        result.append(reads_name+"."+str(segment_suffix[0])+","+str(segment_suffix[1])+".seq")
    return result

def make_segment_namelist(reads_list_list,read_length):
    result=[]
    segment_suffix_list=designsuffix(read_length)
    pair_index=0
    for reads_name_list in reads_list_list:
        result.append([])
        group_index=0
        for reads_name in reads_name_list:
            result[pair_index].append([])
            result[pair_index][group_index]=make_onesegment_namelist(reads_name, read_length)
            group_index+=1
        pair_index+=1
    return result

def junction2boundary(junction):
    readtype=abs(junction[2])
    if readtype==1 or readtype==2:
        a1=int(junction[0])-int(junction[3])+1
        a2=int(junction[1])+int(junction[3])-1
    elif readtype==3:
        a1=int(junction[0])
        a2=int(junction[1])
    elif readtype==4:
        a1=int(junction[0])
        a2=int(junction[1])
    return [a1,a2]

def AddIndexinDict(result,item):
    if result.has_key(item):
        result[item]+=1
    else:
        result[item]=1

######################################################

def DelIteminList(list,delindex_dict):
    delindex_sortedlist=sorted(delindex_dict)
    delindex_sortedlist.sort(reverse=True)
    for delindex in delindex_sortedlist:
        del list[delindex]

def DelLocalHalfMappableHits(temp_list1st,distance_bound):
    delindex_dict={}
    mapping_pos_dict={}
    diff_dict={}
    index=0
    for temp_line1st in temp_list1st:
        temp_line1st_list=temp_line1st.split('\t')
        mapping_pos_dict[int(temp_line1st_list[3])]=index
        index+=1        
    list=sorted(mapping_pos_dict)
    len_list=len(list)
    i=1
    while i<len_list:
        diff_dict[i-1]=list[i]-list[i-1]
        i+=1
    for j in diff_dict:
        if diff_dict[j]<distance_bound:
            AddIndexinDict(delindex_dict,mapping_pos_dict[list[j]])
            AddIndexinDict(delindex_dict,mapping_pos_dict[list[j+1]])
    DelIteminList(temp_list1st,delindex_dict)                   

def AddPosinDict(posdict,temp_list1st,index_1st_2nd):
    for temp_line1st in temp_list1st:
        temp_line1st_list=temp_line1st.split('\t')
        if temp_line1st_list[4]=="R":
            key=0-int(temp_line1st_list[3])
        else:
            key=int(temp_line1st_list[3])
        posdict[key]=index_1st_2nd

def FindExonicRead(good_list,index,temp_list1st,temp_list2nd, Iexonic):
    exonicread_startpt_dict={}
    posdict={}
    diff_dict={}
    AddPosinDict(posdict,temp_list1st,1)
    AddPosinDict(posdict,temp_list2nd,2)
    list=sorted(posdict)
    len_list=len(list)
    i=1
    while i<len_list:
        diff_dict[i-1]=list[i]-list[i-1]
        i+=1
    for j in diff_dict:
        if diff_dict[j]==25:
            if list[j]<0 and list[j+1]<0:
                if posdict[list[j]]==1 and posdict[list[j+1]]==2:
                    AddIndexinDict(exonicread_startpt_dict,list[j+1])
            elif list[j]>0 and list[j+1]>0:
                if posdict[list[j]]==1 and posdict[list[j+1]]==2:
                    AddIndexinDict(exonicread_startpt_dict,list[j])
    if len(exonicread_startpt_dict)>0:
        good_list[index]=[]
    for item in exonicread_startpt_dict:
        if item<0:
            item=0-item
            good_list[index].append([item,item+49,-Iexonic,0])
        elif item>0:
            good_list[index].append([item,item+49,Iexonic,0])            

def checkPairInfo(left_jun_group_list,right_jun_group_list,distance,N_seg):
    result=0
    if left_jun_group_list[0][2]>0 and right_jun_group_list[0][2]<0:
        left_range=junction2boundary(left_jun_group_list[N_seg])
        right_range=junction2boundary(right_jun_group_list[0])
        
        if right_range[0]<distance+left_range[1] and right_range[0]>left_range[0]:
            result=1
            
    elif left_jun_group_list[0][2]<0 and right_jun_group_list[0][2]>0:
        left_range=junction2boundary(left_jun_group_list[0])
        right_range=junction2boundary(right_jun_group_list[N_seg])
        
        if left_range[0]<distance+right_range[1] and left_range[0]>right_range[0]:
            result=1
    return result

################################################################

def AddCoverageDict(result,item,score):
    if result.has_key(item):
        result[item]+=score
    else:
        result[item]=score
        
def addcoverage(coverage_dict,a,score):
    i=a[0]
    while i<=a[1]:
        AddCoverageDict(coverage_dict,i,score)
        i+=1

def junction2coverage(coverage_dict,jun_list,score):
    if abs(jun_list[2])==3:
        a=junction2boundary(jun_list)
        addcoverage(coverage_dict,a,score)
    elif abs(jun_list[2])<3:
        a=junction2boundary(jun_list)
        addcoverage(coverage_dict,[a[0],jun_list[0]],score)
        addcoverage(coverage_dict,[jun_list[1],a[1]],score)

def good_seq(junction,local_a,local_b,read_length):
    splice_local_pt=read_length-junction[3]
    junction[0]=int(junction[0])
    junction[1]=int(junction[1])
    junction[3]=int(junction[3])
    
    if abs(junction[2])<3:
        
        jun_start=junction[0]-(read_length-junction[3])+1
        jun_end=junction[1]+junction[3]

        if splice_local_pt>=local_b:
            resulta=local_a+jun_start-1
            resultb=local_b+jun_start-1
            return [resulta,resultb,0,0]
        
        elif splice_local_pt>=local_a:
            resulta=local_a+jun_start-1
            resultb=junction[0]
            resultc=junction[1]+1
            resultd=local_b+jun_end-read_length
            return [resulta,resultb,resultc,resultd]
        
        elif splice_local_pt<=local_a-1:
            resulta=jun_end-(read_length-local_a)
            resultb=jun_end-(read_length-local_b)
            return [resulta,resultb,0,0]
      
    elif abs(junction[2])==3:
        resulta=local_a+junction[0]-1
        resultb=local_b+junction[0]-1       
        return [resulta,resultb,0,0]
  
    elif abs(junction[2])==4:
        if junction[3]>0:
            if junction[3]>=local_b:
                resulta=local_a+junction[0]-1
                resultb=local_b+junction[0]-1
            elif junction[3]>=local_a:
                resulta=local_a+junction[0]-1
                resultb=junction[1]
            elif junction[3]<local_a:
                resulta=0
                resultb=0
        elif junction[3]<0:
            left_arm=read_length+junction[3]
            local_left_start=left_arm+1
            if local_left_start<=local_a:
                resulta=local_a+junction[0]-local_left_start
                resultb=local_b+junction[0]-local_left_start
            elif local_left_start<=local_b:
                resulta=junction[0]
                resultb=local_b+junction[0]-local_left_start
            elif local_left_start>local_b:
                resulta=0
                resultb=0                
        return [resulta,resultb,0,0]
        
def check_segment_overlap(junctiona, junctionb, lena, lenb, read_length):

    if junctiona[2]<0:
        local_a=lenb[0]-lena[0]+1-25
        local_b=lena[1]-lena[0]+1-25
    else:
        local_a=lenb[0]-lena[0]+1
        local_b=lena[1]-lena[0]+1
    juna_good_seq=good_seq(junctiona,local_a,local_b,read_length)
    if junctionb[2]<0:
        local_a=lenb[0]-lenb[0]+1+25
        local_b=lena[1]-lenb[0]+1+25    
    else:
        local_a=lenb[0]-lenb[0]+1
        local_b=lena[1]-lenb[0]+1
    junb_good_seq=good_seq(junctionb,local_a,local_b,read_length)
    if abs(junctiona[2])<4 and abs(junctionb[2])<4:
        if comparelist(juna_good_seq,junb_good_seq)==0:
            return 1
#### 1 is good over_lap
        else:
            return 0
    elif abs(junctiona[2])==4 and abs(junctionb[2])<4:
        if juna_good_seq[0]>=junb_good_seq[0] and juna_good_seq[1]<=junb_good_seq[1]:
            return 1
        elif juna_good_seq[0]>=junb_good_seq[2] and juna_good_seq[1]<=junb_good_seq[3]:
            return 1
        else:
            return 0
    elif abs(junctiona[2])<4 and abs(junctionb[2])==4:
        if junb_good_seq[0]>=juna_good_seq[0] and junb_good_seq[1]<=juna_good_seq[1]:
            return 1
        elif junb_good_seq[0]>=juna_good_seq[2] and junb_good_seq[1]<=juna_good_seq[3]:
            return 1
        else:
            return 0
    elif abs(junctiona[2])==4 and abs(junctionb[2])==4:
        if junb_good_seq[1]-juna_good_seq[0]==local_b-local_a:
            return 1
        else:
            return 0

def check_singleread_group_result(singleread_group_result,range_list, read_length):
    all_output=[]
    output=[]
##result: good network    
    result={}
##ref_group_index: good_index from 0~i-1    
    ref_group_index=0
##ref_index_list: the good_hit in the previous group(1 is good)
    ref_index_list={}
##the good hit in the current group
    length_segment=len(singleread_group_result)
    if length_segment==1:
        for result in singleread_group_result[0]:
            all_output.append([result])
        return all_output 
    while ref_group_index<length_segment:
        result[ref_group_index]={}
        if ref_group_index==0:
            i=0
            len_list=len(singleread_group_result[ref_group_index])
            while i<len_list:
                ref_index_list[i]=1
                i+=1
        else:
            temp_ref_index_list={}
            result[ref_group_index]={}
            index=0
            for junction in singleread_group_result[ref_group_index]:
                result[ref_group_index][index]=[]
                for ref_index in ref_index_list:
                    if check_segment_overlap(singleread_group_result[ref_group_index-1][ref_index],junction,range_list[ref_group_index-1], range_list[ref_group_index], read_length)==1:
                        result[ref_group_index][index].append(ref_index)
                        if not temp_ref_index_list.has_key(index):
                            temp_ref_index_list[index]=1
                index+=1
            str_temp_ref_index_list=repr(temp_ref_index_list)
            ref_index_list=eval(str_temp_ref_index_list)
        ref_group_index+=1
    ref_group_index=length_segment-1   
    
####     if len(result[ref_group_index])==1:
        
    for index in result[ref_group_index]:
        for good_index in result[ref_group_index][index]:
            one_output=[]
            one_output.append(singleread_group_result[ref_group_index][index])
            new_ref_group_index=ref_group_index-1         
            recursive_record(singleread_group_result,result,new_ref_group_index,good_index,one_output,all_output)
    return all_output

def recursive_record(singleread_group_result,result,ref_group_index,good_index,one_output,all_output):
    if ref_group_index==0:
        one_output.append(singleread_group_result[ref_group_index][good_index])
        all_output.append(one_output)
        one_output=[]
    else:
        one_output.append(singleread_group_result[ref_group_index][good_index])
        new_ref_group_index=ref_group_index-1
        index=good_index
        for good_index in result[ref_group_index][index]:
            recursive_record(singleread_group_result,result,new_ref_group_index,good_index,one_output,all_output)

#############################################################################################

Iextend=4
Iexonic=3
Ijunpositive=1
Ijunnegative=2

genome_filename=""
reads_filename=""
mapping=""
read_len=[]
read_num=0
num_mismatch=2
reads_filename_list_list=[]

jundict={}
coverage_dict={}

temp_path="temp/"

#############################################################################################

if len(sys.argv)>=3:
    genome_filename=sys.argv[1]
    reads_filename_list_list.append(sys.argv[2][2:len(sys.argv[2])])
    for i in sys.argv[3:len(sys.argv)]:
        if i[0]=="L":
            reads_filename_list_list.append(i[2:len(i)])
        elif i[0]=="M":
            num_mismatch=int(i[1:len(i)])
        elif i[0:2]=="-S" or  i[0:2]=="-E" or i[0:2]=="-s" or i[0:2]=="-e":
            mapping=i[1]
else:
    print("usage: ./SpliceMap.py chr1.fa L-reads_list1 [L-reads_list2] -S|-s|-E|-e ")
    sys.exit(1)
i=0
n=0
reads_list_list=[]
reads_list_list.append([])
if len(reads_filename_list_list)==2:
    reads_list_list.append([])
for reads_filename_list_filename in reads_filename_list_list:
    reads_filename_list=open(reads_filename_list_filename,'r')
    for reads_filename_line in reads_filename_list:
        if reads_filename_line.strip()=='':
            continue
        reads_filename=reads_filename_line[0:(len(reads_filename_line)-1)]
        if n==0:
            fullread_length=checklength(reads_filename)
            n+=1
        reads_list_list[i].append(reads_filename)
    i+=1   
    reads_filename_list.close()

#############################################################################################
read_length=50
read_len=["1,25","26,50"]
read_halflen=read_length/2
#############################################################################################

chr=open(genome_filename,"r")
chrlist=chr.readlines()
loops=0
chr_name=chrlist[0][1:len(chrlist[0])-1]
del chrlist[0]
for line in chrlist:
    chrlist[loops]=line.strip().upper()
    loops +=1
chrline="".join(chrlist)
###############################
pos=0
chrsize=len(chrline)
chrdict_10={}
while pos<chrsize:
    key = chrline[pos:(pos+10)]
    if key=="NNNNNNNNNN":
        pos+=1
        continue
    if chrdict_10.has_key(key):
        chrdict_10[key].append(pos+1)
    else:
        chrdict_10[key]=[pos+1]
    pos +=1

############################################################################################
    
list_index=0
print reads_list_list
good_list_file=open(temp_path+chr_name+"_good_list",'w')
for reads_name in reads_list_list[0]:
    reads_filename_pair=[]
    reads_filename_pair.append(reads_name)
    if len(reads_list_list)==2:
        reads_filename_pair.append(reads_list_list[1][list_index])
        list_index+=1
    pair_index=0
    for reads_filename in reads_filename_pair:
        
        ####################################################################################

        reads_filename_group=make_onesegment_namelist(reads_filename,fullread_length)
        print reads_filename_group
        group_result=[]
        suffix_index=0
        suffix_list=designsuffix(fullread_length)
        N_seg=len(suffix_list)-1
        for reads_segment_filename in reads_filename_group:

            t1 = datetime.datetime.now()

            ################################################################################
           
            print reads_segment_filename 
            good_list={}
            
            half1st_filename=temp_path+GetPathAndName(reads_segment_filename)[1]+"."+str(read_len[0])+".seq.out.t"
            half2nd_filename=temp_path+GetPathAndName(reads_segment_filename)[1]+"."+str(read_len[1])+".seq.out.t"
            half1st=open(half1st_filename,'r')
            half2nd=open(half2nd_filename,'r')
            fullreads=open(reads_filename,'r')
            suffix=suffix_list[suffix_index]
            suffix_index+=1
            local_start=suffix[0]
            local_end=suffix[1]
 
            crossjun1st_mix_name=temp_path+chr_name+'crossjun1st_mix'
            crossjun2nd_mix_name=temp_path+chr_name+'crossjun2nd_mix'
            crossjun1st_mix=open(crossjun1st_mix_name,'w')
            crossjun2nd_mix=open(crossjun2nd_mix_name,'w')

            line1st=half1st.readline()
            line2nd=half2nd.readline()

            temp_chr_name=chr_name
            if mapping=="E" or mapping=="e":
                chr_name=chr_name+".fa"
            read_index=1
            line1st=line1st.strip()
            line1st_list=line1st.split('\t')
            read_index1st=int(line1st_list[0])
            if len(line1st_list)>2:
                read_chr_name1st=line1st_list[2]
                read_coor1st=int(line1st_list[3])
            else:
                read_chr_name1st="chr0"
            line2nd=line2nd.strip()
            line2nd_list=line2nd.split('\t')
            read_index2nd=int(line2nd_list[0])
            if len(line2nd_list)>2:
                read_chr_name2nd=line2nd_list[2]
                read_coor2nd=int(line2nd_list[3])
            else:
                read_chr_name2nd="chr0"
            
            while line1st!="" or line2nd!="" :
                temp_list1st=[]
                temp_list2nd=[]
                while read_index1st==read_index:
                    if read_chr_name1st==chr_name:
                        temp_list1st.append(line1st)
                    line1st=half1st.readline()
                    if line1st!="":
                        line1st=line1st.strip()
                        line1st_list=line1st.split('\t')
                        read_index1st=int(line1st_list[0])
                        if len(line1st_list)>2:
                            read_chr_name1st=line1st_list[2]
                            read_coor1st=int(line1st_list[3])
                        else:
                            read_chr_name1st="chr0"
                    else:
                        break

                while read_index2nd==read_index:

                    if read_chr_name2nd==chr_name:
                        temp_list2nd.append(line2nd)
                    line2nd=half2nd.readline()
                    if line2nd!="":
                        line2nd=line2nd.strip()
                        line2nd_list=line2nd.split('\t')
                        read_index2nd=int(line2nd_list[0])
                        if len(line2nd_list)>2:
                            read_chr_name2nd=line2nd_list[2]
                            read_coor2nd=int(line2nd_list[3])                            
                        else:
                            read_chr_name2nd="chr0"
                    else:
                        break
                
                fullline=fullreads.readline()

                linefullreads=fullline[local_start-1:local_end]
                index=str(read_index)
                if len(temp_list1st)>0:
                    DelLocalHalfMappableHits(temp_list1st,400000)
                if len(temp_list2nd)>0:
                    DelLocalHalfMappableHits(temp_list2nd,400000)
                if len(temp_list1st)>0 and len(temp_list2nd)>0:
                    FindExonicRead(good_list,index,temp_list1st,temp_list2nd,Iexonic)
                for temp_line1st in temp_list1st:
                    temp_line1st_list=temp_line1st.split('\t')
		    if int(temp_line1st_list[1][1])<=num_mismatch:
                        if temp_line1st_list[4]=="F":
                            crossjun1st_mix.write(linefullreads.strip() +  " " + temp_line1st_list[0] +  "\t" + linefullreads.strip()[0:read_halflen] +  "\t" + temp_line1st_list[1] + '\t1\t' +temp_line1st_list[2] +  "\t" + temp_line1st_list[3] +  "\t" + temp_line1st_list[4] +  "\t" + temp_line1st_list[0] + "\n")
                        if temp_line1st_list[4]=="R":
                            crossjun2nd_mix.write(linefullreads.strip() +  " " + temp_line1st_list[0] +  "\t" + linefullreads.strip()[0:read_halflen] +  "\t" + temp_line1st_list[1] + '\t1\t' +temp_line1st_list[2] +  "\t" + temp_line1st_list[3] +  "\t" + temp_line1st_list[4] +  "\t" + temp_line1st_list[0] + "\n")
                for temp_line2nd in temp_list2nd:                                                                                                                 
                    temp_line2nd_list=temp_line2nd.split('\t')                                                                                                 
                    if int(temp_line2nd_list[1][1])<=num_mismatch:
                        if temp_line2nd_list[4]=="R":
                            crossjun1st_mix.write(linefullreads.strip() +  " " + temp_line2nd_list[0] +  "\t" + linefullreads.strip()[read_halflen:read_length] +  "\t" + temp_line2nd_list[1] + '\t1\t' +temp_line2nd_list[2] +  "\t" + temp_line2nd_list[3] +  "\t" + temp_line2nd_list[4] +  "\t" + temp_line2nd_list[0] + "\n")
                        if temp_line2nd_list[4]=="F":
                            crossjun2nd_mix.write(linefullreads.strip() +  " " + temp_line2nd_list[0] +  "\t" + linefullreads.strip()[read_halflen:read_length] +  "\t" + temp_line2nd_list[1] + '\t1\t' +temp_line2nd_list[2] +  "\t" + temp_line2nd_list[3] +  "\t" + temp_line2nd_list[4] +  "\t" + temp_line2nd_list[0] + "\n")

                read_index+=1
            chr_name=temp_chr_name
            
            half1st.close()
            half2nd.close()
            crossjun1st_mix.close()
            crossjun2nd_mix.close()
            fullreads.close()

            delta_time1 = datetime.datetime.now()-t1
            print "writemixtime  " + str(delta_time1)

            ################################################################################

            crossjun1st=open(crossjun1st_mix_name,'r')
            crossjun2nd=open(crossjun2nd_mix_name,'r')

            for line1st in crossjun1st:
                line1st_list=line1st.split('\t')
                IRF=1
                if line1st_list[6]=="R":
                    line1st_list[0]=compleseq(line1st_list[0][0:read_length])+" "
                    line1st_list[1]=compleseq(line1st_list[1])
                    IRF=-1
                chr_pos=int(line1st_list[5])+read_halflen-2
                read_pos=read_halflen-1
                line1st_ext=line1st_list[1]

                    #########	extending     ##############
                coord_gt_list=[]
                coord_ct_list=[]

                while chr_pos<(chrsize-read_halflen) and line1st_list[0][read_pos]==chrline[chr_pos]:
                    line1st_ext=line1st_ext+line1st_list[0][read_pos]
                    read_pos +=1
                    chr_pos +=1
                    if chrline[chr_pos:(chr_pos+2)]=="GT":
                        coord_gt_list.append([read_pos,chr_pos])
                    if chrline[chr_pos:(chr_pos+2)]=="CT":
                        coord_ct_list.append([read_pos,chr_pos])
                coord_list=[coord_gt_list,coord_ct_list]
                longest_read_extend_pos=read_pos
                furthest_read_extend_chr_pos=chr_pos

                result_list=[]
                direc_type=0
                for coord_gt_list in coord_list:
                    direc_type+=1
                    for coord_gt in coord_gt_list:
                        read_pos=coord_gt[0]
                        chr_pos=coord_gt[1]
                        line1st_left=line1st_list[0][read_pos:read_length]

                    #########	map "left" [(if)left>=10, (if)1st10 in dict(for), (while+if)check the left.]     ##############
                        if read_pos<(read_length-9):
                            i=10
                            len_line1st_left=len(line1st_left)
                            line1st_left_10=line1st_left[0:10]
                            if chrdict_10.has_key(line1st_left_10):
                                templist=chrdict_10[line1st_left_10]
                                half_distance=cal_half_distance(len_line1st_left)
                                left_indexlist=checkindexlistFwd(chr_pos,templist,half_distance,20)
                                for left_start in left_indexlist:
                                    tempread=chrline[(left_start-1):(left_start+read_halflen-1)]
                                    i=10
                                    len_line1st_left=len(line1st_left)
                                    if (chrline[(left_start-3):(left_start-1)]=="AG" and direc_type==1) or (chrline[(left_start-3):(left_start-1)]=="AC" and direc_type==2) :
                                        while i < len_line1st_left and tempread[i]==line1st_left[i]:
                                            i+=1
                                        if i==len_line1st_left:
                                            result_list.append([chr_pos,left_start,IRF*direc_type,len_line1st_left])

            ###############################
                index=line1st_list[7].strip()
                if longest_read_extend_pos!=50:
                    if good_list.has_key(index):
                        good_list[index].append([furthest_read_extend_chr_pos-longest_read_extend_pos+1,furthest_read_extend_chr_pos,IRF*Iextend,longest_read_extend_pos])
                    else:
                        good_list[index]=[]
                        good_list[index].append([furthest_read_extend_chr_pos-longest_read_extend_pos+1,furthest_read_extend_chr_pos,IRF*Iextend,longest_read_extend_pos]) 
                if longest_read_extend_pos!=50 and len(result_list)==1:
                    result_list[0][1]=result_list[0][1]-1
                    Indicator_exist=0
                    if good_list.has_key(index):
                        Indicator_exist=0
                        for result_jun in good_list[index]:
                            if comparelist(result_list[0],result_jun)==0:
                                Indicator_exist+=1
                        if Indicator_exist==0:
                            good_list[index].append(result_list[0])
                    else:
                        good_list[index]=[]                                                                                                                                                                                       
                        good_list[index].append(result_list[0])
            good_list1st=good_list

            ################################################################################
            good_list={}

            for line2nd in crossjun2nd:
                line2nd_list=line2nd.split('\t')
                IRF=1
                if line2nd_list[6]=="R":
                    line2nd_list[0]=compleseq(line2nd_list[0][0:read_length])+" "
                    line2nd_list[1]=compleseq(line2nd_list[1])
                    IRF=-1
                chr_pos=int(line2nd_list[5])-1
                read_pos=read_halflen
                line2nd_ext=line2nd_list[1]

                    #########	extending     ##############
                coord_gt_list=[]
                coord_ct_list=[]

                while chr_pos > (read_halflen-1) and line2nd_list[0][read_pos]==chrline[chr_pos]:
                    line2nd_ext=line2nd_list[0][read_pos]+line2nd_ext
                    read_pos -=1
                    chr_pos -=1
                    if chrline[chr_pos-1:(chr_pos+1)]=="AG":
                        coord_gt_list.append([read_pos,chr_pos])
                    if chrline[chr_pos-1:(chr_pos+1)]=="AC":
                        coord_ct_list.append([read_pos,chr_pos])
                coord_list=[coord_gt_list,coord_ct_list]
                longest_read_extend_pos=read_pos
                furthest_read_extend_chr_pos=chr_pos

                result_list=[]
                direc_type=0
                for coord_gt_list in coord_list:
                    direc_type+=1
                    for coord_gt in coord_gt_list:
                        read_pos=coord_gt[0]
                        chr_pos=coord_gt[1]
                        line2nd_left=line2nd_list[0][0:(read_pos+1)]

                    #########	map "left" [(if)left>=10, (if)2nd10 in dict(for), (while+if)check the left.]     ##############
                        if read_pos>8:
                            i=10
                            len_line2nd_left=len(line2nd_left)
                            line2nd_left_10=line2nd_left[(len_line2nd_left-10):len_line2nd_left]
                            if chrdict_10.has_key(line2nd_left_10):
                                templist=chrdict_10[line2nd_left_10]
                                half_distance=cal_half_distance(len_line2nd_left)
                                left_indexlist=checkindexlistRes(chr_pos,templist,half_distance,20)
                                for left_start in left_indexlist:
                                    tempread=chrline[(left_start-read_halflen+9):(left_start+9)]
                                    i=10
                                    if (chrline[(left_start+9):(left_start+11)]=="GT" and direc_type==1) or (chrline[(left_start+9):(left_start+11)]=="CT" and direc_type==2) :
                                        while i < len_line2nd_left and tempread[(read_halflen-i-1)]==line2nd_left[(len_line2nd_left-i-1)]:
                                            i+=1
                                        if i==len_line2nd_left:
                                            result_list.append([chr_pos,left_start,IRF*direc_type,len_line2nd_left])

            ###############################
                index=line2nd_list[7].strip()
                if longest_read_extend_pos!=-1:
                    if good_list.has_key(index):
                        good_list[index].append([furthest_read_extend_chr_pos+2,50-longest_read_extend_pos+furthest_read_extend_chr_pos,IRF*Iextend,longest_read_extend_pos-49])
                    else:
                        good_list[index]=[]
                        good_list[index].append([furthest_read_extend_chr_pos+2,50-longest_read_extend_pos+furthest_read_extend_chr_pos,IRF*Iextend,longest_read_extend_pos-49])
                if longest_read_extend_pos!=-1 and len(result_list)==1:
                    result_list[0][0]=result_list[0][0]+1
                    result_list[0][1]=result_list[0][1]+9
                    temp=result_list[0][0]
                    result_list[0][0]=result_list[0][1]
                    result_list[0][1]=temp
                    result_list[0][3]=read_length-result_list[0][3]

                    Indicator_exist=0
                    if good_list.has_key(index):
                        Indicator_exist=0
                        for result_jun in good_list[index]:
                            if comparelist(result_list[0],result_jun)==0:
                                Indicator_exist+=1
                        if Indicator_exist==0:
                            good_list[index].append(result_list[0])
                    else:
                        good_list[index]=[]                                                                                                                                                                                       
                        good_list[index].append(result_list[0])                                                                                                                                                                                       

            good_list2nd=good_list
            good_list=checkgoodlists(good_list1st, good_list2nd)

            crossjun1st.close()
            crossjun2nd.close()
            group_result.append(good_list)

            ################################################################################
########  
        i=1
        group_filtered_result_list={}
        while i<read_index:
            str_i=str(i)
            singleread_group_result=[]

            Indicator_empty_list=0
            for groupmenber_result_list in group_result:
                if groupmenber_result_list.has_key(str_i):
                    singleread_group_result.append(groupmenber_result_list[str_i])
                else:
                    singleread_group_result.append([])
                    Indicator_empty_list+=1
                  
            if Indicator_empty_list==0:
                group_filtered_result_list[str_i]=check_singleread_group_result(singleread_group_result,suffix_list,50)
            i+=1
########
 
        if pair_index==0:
            pairleft_list=group_filtered_result_list
            pairright_list={}
        if pair_index==1:
            pairright_list=group_filtered_result_list
        pair_index+=1

       ####################################################################################
    
    output_left_good_list={}
    output_right_good_list={}
    for left in pairleft_list:
        if len(reads_list_list)==1 or pairright_list.has_key(left):
            if len(reads_list_list)==1 :
                for jun_group_list in pairleft_list[left]:
                    for jun_list in jun_group_list:


                        if abs(jun_list[2])<4:
                            output_left_good_list[left].append(jun_list)
                            junction2coverage(coverage_dict,jun_list,1)

                        if abs(jun_list[2])<3:
                            chr_pos=jun_list[0]
                            left_start=jun_list[1]
                            direc_type=jun_list[2]
                            right_length=jun_list[3]

                            if jundict.has_key(chr_pos):
                                if jundict[chr_pos].has_key(left_start):
                                    jundict[chr_pos][left_start][0] += 1
                                    if jundict[chr_pos][left_start][2].has_key(right_length):
                                        jundict[chr_pos][left_start][2][right_length] += 1
                                    else:
                                        jundict[chr_pos][left_start][2][right_length] = 1
                                else:
                                    identical_read={}
                                    identical_read[right_length]=1
                                    jundict[chr_pos][left_start]=[1,direc_type,identical_read]
                            else:
                                jundict[chr_pos]={}
                                identical_read={}
                                identical_read[right_length]=1
                                jundict[chr_pos][left_start]=[1,direc_type,identical_read]

            elif len(reads_list_list)==2:
                left_dict={}
                right_dict={}
                left_jun_index=0
                for left_jun_group_list in pairleft_list[left]:
                    right_jun_index=0

                    for right_jun_group_list in pairright_list[left]:
                        if checkPairInfo(left_jun_group_list,right_jun_group_list,400000,N_seg)==1:
                            if left_dict.has_key(left_jun_index):
                                left_dict[left_jun_index]+=1
                            else:
                                left_dict[left_jun_index]=0
                            if right_dict.has_key(right_jun_index):
                                right_dict[right_jun_index]+=1
                            else:
                                right_dict[right_jun_index]=0                                
                        right_jun_index+=1
                    left_jun_index+=1


                if len(left_dict)>0:
                    output_left_good_list[left]=[]

                for left_jun_index in left_dict:

                    jun_group_list=pairleft_list[left][left_jun_index]
                    
                    for jun_list in jun_group_list:
                    
                        if abs(jun_list[2])<4:
                            output_left_good_list[left].append(jun_list)
                            junction2coverage(coverage_dict,jun_list,1)
                            
                        if abs(jun_list[2])<3:
                            chr_pos=jun_list[0]
                            left_start=jun_list[1]
                            direc_type=jun_list[2]
                            right_length=jun_list[3]


                            if jundict.has_key(chr_pos):
                                if jundict[chr_pos].has_key(left_start):
                                    jundict[chr_pos][left_start][0] += 1
                                    if jundict[chr_pos][left_start][2].has_key(right_length):
                                        jundict[chr_pos][left_start][2][right_length] += 1
                                    else:
                                        jundict[chr_pos][left_start][2][right_length] = 1
                                else:
                                    identical_read={}
                                    identical_read[right_length]=1
                                    jundict[chr_pos][left_start]=[1,direc_type,identical_read]
                            else:
                                jundict[chr_pos]={}
                                identical_read={}
                                identical_read[right_length]=1
                                jundict[chr_pos][left_start]=[1,direc_type,identical_read]

                if len(right_dict)>0:
                    output_right_good_list[left]=[]

                for right_jun_index in right_dict:

                    jun_group_list=pairright_list[left][right_jun_index]
                    
                    for jun_list in jun_group_list:
                    
                        if abs(jun_list[2])<4:
                            output_right_good_list[left].append(jun_list)
                            junction2coverage(coverage_dict,jun_list,1)
                        if abs(jun_list[2])<3:
                            chr_pos=jun_list[0]
                            left_start=jun_list[1]
                            direc_type=jun_list[2]
                            right_length=jun_list[3]


                            if jundict.has_key(chr_pos):
                                if jundict[chr_pos].has_key(left_start):
                                    jundict[chr_pos][left_start][0] += 1
                                    if jundict[chr_pos][left_start][2].has_key(right_length):
                                        jundict[chr_pos][left_start][2][right_length] += 1
                                    else:
                                        jundict[chr_pos][left_start][2][right_length] = 1
                                else:
                                    identical_read={}
                                    identical_read[right_length]=1
                                    jundict[chr_pos][left_start]=[1,direc_type,identical_read]
                            else:
                                jundict[chr_pos]={}
                                identical_read={}
                                identical_read[right_length]=1
                                jundict[chr_pos][left_start]=[1,direc_type,identical_read]                        


    str_output_left_good_list=repr(output_left_good_list)
    str_output_right_good_list=repr(output_right_good_list)

    good_list_file.write(str_output_left_good_list+"\n")
    good_list_file.write(str_output_right_good_list+"\n")
good_list_file.close()

#############################################################################################

wigname=temp_path+chr_name+"coverage.wig"
coverage=open(wigname,'w')
for pos in coverage_dict:
    coverage.write(chr_name+"\t"+str(pos)+"\t"+str(pos)+"\t"+str(coverage_dict[pos])+"\n")
coverage.close()

#############################################################################################

str_jundict=repr(jundict)
jundict_file=open(temp_path+chr_name+"_jundict",'w')
jundict_file.write(str_jundict)
jundict_file.close()

#############################################################################################

bedname=temp_path+chr_name+"junction.bed"
junction=open(bedname,'w')
number=1
junction.write("track name=junctions description=\"SpliceMap junctions\"\n")

for leftpos in jundict:
    for rightpos in jundict[leftpos]:
#        count=jundict[leftpos][rightpos][0]
        count=1
        str_leftpos=str(leftpos-count)
        str_rightpos=str(rightpos+count)
        str_count=str(count)
        str_length=str(rightpos-leftpos+count)
        str_right_length=str(rangedict(jundict[leftpos][rightpos][2])) + "_" + str(len(jundict[leftpos][rightpos][2]))
        str_direc=directranslate(jundict[leftpos][rightpos][1])
        junction.write(chr_name + "\t" + str_leftpos + "\t" + str_rightpos + "\t" + "Jun" + str(number) + "(" + str(jundict[leftpos][rightpos][0]) + ")" + "[" + str_right_length + "]" + "\t" + str_count + "\t" + str_direc + "\t" + str_leftpos + "\t" + str_rightpos + "\t" + "255,0,0\t2" + "\t" + str_count +","+str_count+ "\t" +"0,"+str_length+"\n")
        number += 1

#############################################################################################

refname=temp_path+chr_name+"junction_ref.txt"
junction_ref=open(refname,'w')
number=1

for leftpos in jundict:
    for rightpos in jundict[leftpos]:
        str_count=str(jundict[leftpos][rightpos][0])
        str_direc=directranslate(jundict[leftpos][rightpos][1])
        str_number=str(number)
        str_right_length=str(rangedict(jundict[leftpos][rightpos][2])) + "_" + str(len(jundict[leftpos][rightpos][2]))
        A=str(leftpos-1)
        B=str(leftpos)        
        C=str(rightpos)
        D=str(rightpos+1)
        junction_ref.write("Jun" + str_number+ "(" + str_count + ")" + "[" + str_right_length + "]" + "\t" + "Jun" + str_number + "\t" + chr_name + "\t" + str_direc + "\t" + A + "\t" + D + "\t" + A + "\t" + D + "\t" + "2" + "\t" + A + "," + C + "," + "\t" + B + "," + D + "," + "\n")
        number += 1

#############################################################################################

crossjun1st.close()
crossjun2nd.close()
junction.close()
junction_ref.close()

delta_t = datetime.datetime.now() - t0 
print "\t" + chr_name + "-running time: " + str(delta_t)



