#!/usr/bin/python

import sys
import os
import datetime

t0 = datetime.datetime.now()

#############################################################################################


def junction2boundary(junction):
    readtype=abs(junction[2])
    if readtype==1 or readtype==2:
        a1=int(junction[0])-(50-int(junction[3]))+1
        a2=int(junction[1])+int(junction[3])-1
    elif readtype==3:
        a1=int(junction[0])
        a2=int(junction[1])
    elif readtype==4:
        a1=int(junction[0])
        a2=int(junction[1])
    return [a1,a2]



def checklength(filename):
    n=0
    file=open(filename, 'r')
    for line in file:
        if n==0:
            read_len=len(line)-1
            n+=1
        else:
            continue
    return read_len

def designsuffix(read_length):
    result=[]
    if read_length==100:
        result.append([1,50])
        result.append([26,75])
        result.append([51,100])
    elif read_length==75:
        result.append([1,50])
        result.append([26,75])
    elif read_length==50:
        result.append([1,50])
    return result

def make_onesegment_namelist(reads_name, read_length):
    result=[]
    segment_suffix_list=designsuffix(read_length)
    for segment_suffix in segment_suffix_list:
                result.append(reads_name+"."+str(segment_suffix[0])+","+str(segment_suffix[1])+".seq")
    return result

def make_segment_namelist(reads_list_list,read_length):
    result=[]
    segment_suffix_list=designsuffix(read_length)
    pair_index=0
    for reads_name_list in reads_list_list:
        result.append([])
        group_index=0
        for reads_name in reads_name_list:
            result[pair_index].append([])
            result[pair_index][group_index]=make_onesegment_namelist(reads_name, read_length)
            group_index+=1
        pair_index+=1
    return result
################################################################################


def ContMultiResult(jun_list_list):
    result=0
    if len(jun_list_list)==0:
        return 0
    for jun_list in jun_list_list:
#        print jun_list
        if abs(jun_list[2])<4:
            result+=1
    return result
    
def mergegoodlist(ref_good_list,segment_good_list):
    for index in segment_good_list:
        if ref_good_list.has_key(index):
            ref_good_list[index]+=ContMultiResult(segment_good_list[index])
        else:
            ref_good_list[index]=ContMultiResult(segment_good_list[index])

def mergegoodlist_batch(ref_good_list_dict,chr_name,segment_file_list):
    chr_good_list_file=open(chr_name+"_good_list",'r')
    print segment_file_list
    print "kinfai"
    for segment_filename in segment_file_list:
        segment_good_list=eval(chr_good_list_file.readline().strip())

        if ref_good_list_dict.has_key(segment_filename):
            mergegoodlist(ref_good_list_dict[segment_filename],segment_good_list)
        else:
            ref_good_list_dict[segment_filename]={}
            mergegoodlist(ref_good_list_dict[segment_filename],segment_good_list)
    chr_good_list_file.close()
        
#def junction2coverage(coverage_dict,jun_list,score):
#    if abs(jun_list[2])==3:
#        a=junction2boundary(jun_list)
#        addcoverage(coverage_dict,a,score)
#    elif abs(jun_list[2])<3:
#        a=junction2boundary(jun_list)
#        addcoverage(coverage_dict,[a[0],jun_list[0]],score)
#        addcoverage(coverage_dict,[jun_list[1],a[1]],score)


def calculatecoverage(ref_good_list_dict,chr_name,segment_file_list,coverage_dict,jundict):
    chr_good_list_file=open(chr_name+"_good_list",'r')
    for segment_filename in segment_file_list:
        segment_good_list=eval(chr_good_list_file.readline().strip())
#        print segment_good_list
        for index in segment_good_list:
            if ref_good_list_dict[segment_filename][index]==1:
                score=1
            elif ref_good_list_dict[segment_filename][index]>1:
                score=-1
            for jun_list in segment_good_list[index]:
#                print "score  "+str(score)
#                print jun_list
                junction2coverage(coverage_dict,jun_list,score)                    
                if abs(jun_list[2])<3:
                    chr_pos=jun_list[0]
                    left_start=jun_list[1]
                    direc_type=jun_list[2]
                    right_length=jun_list[3]

                    if jundict.has_key(chr_pos):
                        if jundict[chr_pos].has_key(left_start):
                            jundict[chr_pos][left_start][0] += 1
                            if jundict[chr_pos][left_start][2].has_key(right_length):
                                jundict[chr_pos][left_start][2][right_length] += 1
                            else:
                                jundict[chr_pos][left_start][2][right_length] = 1
                        else:
                            identical_read={}
                            identical_read[right_length]=1
                            jundict[chr_pos][left_start]=[1,direc_type,identical_read]
                    else:
                        jundict[chr_pos]={}
                        identical_read={}
                        identical_read[right_length]=1
                        jundict[chr_pos][left_start]=[1,direc_type,identical_read]



################################################################

def AddCoverageDict(result,item,score):
    if score>0:
        index=0
    if score<0:
        index=1
    if result.has_key(item):
        result[item][index]+=score
    else:
        result[item]=[0,0]
        result[item][index]=score

def addcoverage(coverage_dict,a,score):
    i=a[0]
    while i<=a[1]:
        AddCoverageDict(coverage_dict,i,score)
        i+=1

def junction2coverage(coverage_dict,jun_list,score):
    if abs(jun_list[2])==3:
        a=junction2boundary(jun_list)
        addcoverage(coverage_dict,a,score)
    elif abs(jun_list[2])<3:
        a=junction2boundary(jun_list)
#        #print "dddd"
#        print [a[0],jun_list[0],a[0]]
#        print [jun_list[1],a[1]]
        addcoverage(coverage_dict,[a[0],jun_list[0]],score)
        addcoverage(coverage_dict,[jun_list[1],a[1]],score)

###############################################################################




#############################################################################################
genome_filename=""
reads_filename=""
mapping=""
read_len=[]
read_num=0
num_mismatch=2
reads_filename_list_list=[]

if len(sys.argv)>=3:
    genome_filename=sys.argv[1]
    reads_filename_list_list.append(sys.argv[2][2:len(sys.argv[2])])
    for i in sys.argv[3:len(sys.argv)]:
        if i[0]=="L":
            reads_filename_list_list.append(i[2:len(i)])
        elif i[0]=="M":
            num_mismatch=int(i[1:len(i)])
        elif i[0]=="S":
            mapping="S"
else:
    print("usage: ./mergecoverage.py chr_list L-reads_list1 L-reads_list2 M1 ")
    sys.exit(1)
i=0
n=0
reads_list_list=[]
reads_list_list.append([])
if len(reads_filename_list_list)==2:
    reads_list_list.append([])
for reads_filename_list_filename in reads_filename_list_list:
    reads_filename_list=open(reads_filename_list_filename,'r')
    for reads_filename_line in reads_filename_list:
        if reads_filename_line.strip()=='':
            continue
        reads_filename=reads_filename_line[0:(len(reads_filename_line)-1)]

        if n==0:
            read_length=checklength(reads_filename)
            read_length=50
            read_halflen=read_length/2
            read_len=[]
            read_len.append('1,'+str(25))
            read_len.append(str(26)+','+str(50))
            n+=1
        reads_list_list[i].append(reads_filename)
        mapping_log_filename=reads_filename+".log"
        os.system("rm -rf "+mapping_log_filename)

    i+=1   
    reads_filename_list.close()

reads_list_list_list=make_segment_namelist(reads_list_list,read_length)
print reads_list_list_list
read_file_index=0
segment_file_list=[]
for reads_left_list in reads_list_list_list[0]:
    reads_right_list=reads_list_list_list[1][read_file_index]
#    print reads_left_list
#    print "diana"
#    print reads_right_list
    segment_index=0
    for segment_left_filename in reads_left_list:
        segment_right_filename=reads_right_list[segment_index]
        segment_file_list.append(segment_left_filename)
        segment_file_list.append(segment_right_filename)
        segment_index+=1
    read_file_index+=1
chr_list_file=open(genome_filename,'r')
chr_list=[]
for chr_name in chr_list_file:
    chr_name=chr_name.strip().split('.')[0]
    chr_list.append(chr_name)

ref_good_list_dict={}   
for chr_name in chr_list:
    mergegoodlist_batch(ref_good_list_dict,chr_name,segment_file_list) 

ref_good_list_dict_file=open("ref_good_list_dict",'w')
ref_good_list_dict_file.write(repr(ref_good_list_dict)+"\n")
ref_good_list_dict_file.close()
############################################################################################
#jundict={}
#for chr_name in chr_list:
#    coverage_dict={}
#    calculatecoverage(ref_good_list_dict,chr_name,segment_file_list,coverage_dict,jundict)
   
#    wigname=chr_name+"_coverage.wig"
#    coverage=open(wigname,'w')
    
#    for pos in coverage_dict:
    #    n=coverage_dict[pos][0]+abs(coverage_dict[pos][1])
    #    coverage.write(chr_name+"\t"+str(pos)+"\t"+str(n)+str(coverage_dict[pos][0])+"\t"+str(coverage_dict[pos][1])+"\n")
#        if not coverage_dict[pos][0]==0:
#            coverage.write(chr_name+"\t"+str(pos)+"\t"+str(pos)+"\t"+str(coverage_dict[pos][0])+"\n")
#        if not coverage_dict[pos][1]==0:
#            coverage.write(chr_name+"\t"+str(pos)+"\t"+str(pos)+"\t"+str(coverage_dict[pos][1])+"\n")

#    coverage.close()


delta_t = datetime.datetime.now() - t0 
print "\t" + chr_name + "-running time: " + str(delta_t)
