#!/usr/bin/python
import sys
import os
import datetime

#################################
def rearrange_eland_multi_map(string,n,Num_map):
    string=string.strip()
    chr_fa_name=""
    RU=''
    output=[]
    list=string.split(',')
    if Num_map=='1':
        RU='U'
    else:
        RU='R'
    for item in list:
        if item[0:3]=="chr":
            item_list=item.split(':')
            chr_fa_name=item_list[0]
            pos=item_list[1]
        else:
            pos=item
        len_pos=len(pos)
        mismatch=int(pos[len_pos-1:len_pos])
        if mismatch==n:
            output.append(RU+str(mismatch)+'\t'+chr_fa_name+'\t'+pos[0:len_pos-2]+'\t'+pos[len_pos-2:len_pos-1])
    return output
#################################

t0 = datetime.datetime.now()

if len(sys.argv)>=2:
    input_filename=sys.argv[1]
    output_filename="R_"+input_filename
    for i in sys.argv[2:len(sys.argv)]:
        if i[0]=="-":
            mapping_opt=i[1]
        else:
            output_filename=i


else:
    print("usage: ./process_multi.py mapping_result [output] [-s]" )
    sys.exit(1)

input=open(input_filename,'r')
output=open(output_filename,'w')
for line in input:
    line=line.strip()
    line_list=line.split('\t')
    line_0_list=line_list[0].split('-')
    len_line_0_list=len(line_0_list)
    index=line_0_list[len_line_0_list-1:len_line_0_list]
    if (line_list[2]!="NM" and line_list[2]!="QC"):
        mismatch=2
        line_2_list=line_list[2].split(':')
        if line_2_list[0]!='0':
            mismatch=0
            if int(line_2_list[0])>10:
                output.write(index[0]+'\t'+"R"+str(mismatch)+'\n')
            else:
                mapping_list=rearrange_eland_multi_map(line_list[3],mismatch,line_2_list[mismatch])
                for mapping_result in mapping_list:
                    output.write(index[0]+'\t'+mapping_result+'\n')
         
        elif line_2_list[1]!='0':
            mismatch=1
            if int(line_2_list[1])>10:
                output.write(index[0]+'\t'+"R"+str(mismatch)+'\n')
            else:
                mapping_list=rearrange_eland_multi_map(line_list[3],mismatch,line_2_list[mismatch])
                for mapping_result in mapping_list:
                    output.write(index[0]+'\t'+mapping_result+'\n')
        else:
            mismatch=2
            if int(line_2_list[2])>10:
                output.write(index[0]+'\t'+"R"+str(mismatch)+'\n')
            else:
                mapping_list=rearrange_eland_multi_map(line_list[3],mismatch,line_2_list[mismatch])
                for mapping_result in mapping_list:
                    output.write(index[0]+'\t'+mapping_result+'\n')

          
    elif line_list[2]=="NM":
        output.write(index[0]+'\t'+"NM"+'\n')
    elif line_list[2]=="QC":
        output.write(index[0]+'\t'+"QC"+'\n')


output.close()
input.close()
delta_t = datetime.datetime.now() - t0


print "end"
print "running time: " + str(delta_t)


