#!/usr/bin/python

import sys
import os
import datetime

t1 = datetime.datetime.now()

################################################################################

def GetPathAndName(path_filename):
    list=path_filename.split('/')
    filename=list[len(list)-1]
    path=path_filename[0:len(path_filename)-len(filename)]
    return [path, filename]
                            
def checklength(filename):
    n=0
    file=open(filename, 'r')
    read_length=len(file.readline().strip())
    file.close()
    return read_length



def designsuffix(read_length):
    result=[]
    if read_length==100:
        result.append([1,50])
        result.append([26,75])
        result.append([51,100])
    elif read_length==75:
        result.append([1,50])
        result.append([26,75])
    elif read_length==50:
        result.append([1,50])
    return result

def make_onesegment_namelist(reads_name, read_length):
    result=[]
    segment_suffix_list=designsuffix(read_length)
    for segment_suffix in segment_suffix_list:
        result.append(reads_name+"."+str(segment_suffix[0])+","+str(segment_suffix[1])+".seq")
    return result

def make_segment_namelist(reads_list_list,read_length):
    result=[]
    segment_suffix_list=designsuffix(read_length)
    pair_index=0
    for reads_name_list in reads_list_list:
        result.append([])
        group_index=0
        for reads_name in reads_name_list:
            result[pair_index].append([])
            result[pair_index][group_index]=make_onesegment_namelist(reads_name, read_length)
            group_index+=1
        pair_index+=1
    return result

###############################################################################
def eland(filename,genome_direc,length,mapping_mismatch,segment_suffix,package_path_filename):
    
    local_filename=GetPathAndName(filename)[1]+"."+str(segment_suffix[0])+","+str(segment_suffix[1])+".seq"
    filename_cut=local_filename + "."+length+".seq"
    output_filename=filename_cut+".out.t"

    start=int(segment_suffix[0])
    local_length=str(int(length.split(',')[0])+start-1)+','+str(int(length.split(',')[1])+start-1)
                      
    cmd="cut -c" + str(int(length.split(',')[0])+start-1) + "-" + str(int(length.split(',')[1])+start-1) + " " + filename + " > temp/"  + filename_cut
    print cmd
    os.system(cmd)
    cmd= package_path_filename[0]+"eland_25 temp/" + filename_cut +" " +genome_direc+ " temp/" + filename_cut + ".out" + " --multi=10 "
    print cmd
    os.system(cmd)
    
##############################################################################
genome_direc=""
reads_filename=""
ref_filename=""
mapping_opt=""
read_len=[]
read_num=0
num_mismatch=1
mapping_mismatch=2
reads_filename_list_list=[]
temp_path="temp/"
if len(sys.argv)>=3:
    genome_direc=sys.argv[1]
    reads_filename_list_list.append(sys.argv[2][2:len(sys.argv[2])])
    for i in sys.argv[3:len(sys.argv)]:
        if i[0]=="L":
            reads_filename_list_list.append(i[2:len(i)])
        elif i[0]=="M":
            num_mismatch=int(i[1:len(i)])
        elif i[0]=="R":
            ref_filename=i[2:len(i)]
        elif i[0:2]=="-S" or i[0:2]=="-E" or i[0:2]=="-s" or i[0:2]=="-e":
            mapping_opt=i[1]

else:
    print("usage: ./run.py genome_directory L-reads_list1 L-reads_list2 M1 R-refFlat.txt")
    sys.exit(1)
package_path_filename=GetPathAndName(sys.argv[0])
package_path=package_path_filename[0]
ref_path_filename=GetPathAndName(ref_filename)
if not genome_direc[-1]=="/":
    genome_direc=genome_direc+'/'
cmd="mkdir temp"
os.system(cmd)
#########################################################################################
print mapping_opt
i=0
n=0
reads_list_list=[]
reads_list_list.append([])
if len(reads_filename_list_list)==2:
        reads_list_list.append([])
t2 = datetime.datetime.now()
for reads_filename_list_filename in reads_filename_list_list:
    reads_filename_list=open(reads_filename_list_filename,'r')
    for reads_filename_line in reads_filename_list:
        if reads_filename_line.strip()=='':
            continue
        reads_filename=reads_filename_line[0:(len(reads_filename_line)-1)]
        if n==0:
            fullread_length=checklength(reads_filename)
            n+=1
        reads_list_list[i].append(reads_filename)
    i+=1   
    reads_filename_list.close()

    
read_len=["1,25","26,50"]
list_index=0
print reads_list_list
if mapping_opt=="S":
    cmd= "cat "+ genome_direc +"chr*.fa > "+ genome_direc +"genome.fa"
    print cmd
    os.system(cmd)
elif mapping_opt=="E":
    cmd="squashGenome " + genome_direc + " " +genome_direc+"chr*.fa"
    print cmd
    os.system(cmd)

for reads_name in reads_list_list[0]:
    reads_filename_pair=[]
    reads_filename_pair.append(reads_name)
    if len(reads_list_list)==2:
        reads_filename_pair.append(reads_list_list[1][list_index])
        list_index+=1
    pair_index=0
    for reads_filename in reads_filename_pair:
        
        ####################################################################################
        print reads_filename
        reads_filename_group=make_onesegment_namelist(reads_filename,fullread_length)
        print reads_filename_group
        group_result=[]
        segment_suffix_list=designsuffix(fullread_length)
        segment_suffix_list_index=0
        for reads_segment_filename in reads_filename_group:
            segment_suffix=segment_suffix_list[segment_suffix_list_index]

            for length in read_len:
                output_filename=GetPathAndName(reads_segment_filename)[1]+"."+str(length)+".seq.out"
                if mapping_opt=="S":
                    cmd = package_path+"seqmap " + str(mapping_mismatch) + " " + reads_filename + " " + genome_direc + "genome.fa"+ " temp/" + output_filename +" /eland:3"
                    if length!="":
                        start=int(segment_suffix[0])
                        local_length=str(int(length.split(',')[0])+start-1)+','+str(int(length.split(',')[1])+start-1)
                        cmd = cmd + " /cut:" + local_length
                    print cmd
                    os.system(cmd)

                if mapping_opt=="E":
                    eland(reads_filename,genome_direc,length,str(mapping_mismatch),segment_suffix,package_path_filename)


####################################################################################
                cmd=package_path+'process_multi_map.py temp/' + output_filename + " temp/" + output_filename +'.t'
                print cmd
                os.system(cmd)

####################################################################################
                
            segment_suffix_list_index+=1
delta_t = datetime.datetime.now() - t2
print "mapping running time: " + str(delta_t)
#########################################################################################
t0 = datetime.datetime.now()
cmd="echo \""+package_path+"SpliceMap.py \$1 L-" + reads_filename_list_list[0]
if len(reads_filename_list_list)==2:
    cmd=cmd+" L-"+ reads_filename_list_list[1]
cmd=cmd+" M" + str(num_mismatch)+" -"+mapping_opt+"\" > "+temp_path+"batch.sp"
print cmd
os.system(cmd)
cmd="chmod 755 "+temp_path+"batch.sp"
print cmd
os.system(cmd)

cmd="find " +genome_direc + " -name " +"\"chr*.fa\" " + "-print -exec ./"+temp_path+"batch.sp {} \;"
print cmd
os.system(cmd)
delta_t = datetime.datetime.now() - t0
print "main part running time: " + str(delta_t)

cmd= "cat "+temp_path+"chr*.bed > "+temp_path+"junction.beds"
os.system(cmd)
cmd= "cat "+temp_path+"chr*ref.txt > "+temp_path+"junction_ref.txt"
os.system(cmd)
cmd= "wc -l "+ temp_path+"chr*ref.txt > "+temp_path+"log1"
os.system(cmd)
cmd= package_path+"deltitle.py "+temp_path+"junction.beds "+ temp_path+"junction.bed" 
os.system(cmd)
#############################################
#########################################################################################
if len(ref_filename)!=0:
    cmd=package_path+"novel_junction.py " + ref_filename + " "+temp_path+"junction.bed"+" "+temp_path+"junction_ref.txt"
    os.system(cmd)
#########################################################################################
cmd=package_path+"stat.py "+temp_path+"junction.bed "+temp_path+"junction.bed.new.bed > "+temp_path+"log2"
os.system(cmd)
cmd="cat "+temp_path+"log1 "+temp_path+"log2 > log"
os.system(cmd)
cmd="cat "+temp_path+"chr*wig > coverage.wig"
os.system(cmd)
#########################################################################################
cmd="mv "+temp_path+"junction.bed "+temp_path+"junction.bed.new.bed ."
os.system(cmd)
#cmd="rm chr*bed chr*ref.txt junction.beds *mix log1 log2 " + genome_direc+"genome.fa"
#print cmd
#os.system(cmd)
delta_t = datetime.datetime.now() - t1
print "running time: " + str(delta_t)


