#!/usr/bin/python

import sys
import os
import datetime

###############################################################
def file_index(filename):
    i=filename
    if i[len(i)-4:len(i)]==".bed":
        index=3
    elif i[len(i)-8:len(i)]=="_ref.txt":
        index=0
    return index
###############################################################
filename_list=[]
lowbound_indep_read=31
if len(sys.argv)>=2:
    for i in sys.argv[1:len(sys.argv)]:
        if i[0]=="N":
            lowbound_indep_read=int(i[1:len(i)])
        else:
            filename_list.append(i)
       
else:
    print("usage: ./stat.py junction.bed newjun.bed N10")
    sys.exit(1)

###############################################################

def count_read(junction,indicator,index):
    c1=c2=c3=c4=c5=c6=c7=total=num_junction=0
    for line in junction:
        if line[0:5]=='track':
            continue
        line_list=line.split('\t')
        depth=int(line_list[index].split('(')[1].split(')')[0])
        num_junction+=1
        total=total+depth
        if depth==1:
            c1+=1
        if depth>1 and depth<=5:
            c2+=1
        if depth>5 and depth<=20:
            if indicator==1:
                print "5-20 :" + line
            c3+=1
        if depth>20 and depth<=50:
            if indicator==1:
                print "20-50 :" + line
            c4+=1
        if depth>50 and depth<=200:
            if indicator==1:
                print "50-200 :" + line
            c5+=1
        if depth>200 and depth<=1000:
            if indicator==1:
                print "200-1000 :" + line
            c6+=1
        if depth>1000:
            if indicator==1:
                print "1000+ :" + line
            c7+=1
    sum=c1+c2+c3+c4+c5
    ave=total/num_junction
    print "total :\t\t" + str(total)
    print "ave :\t\t" + str(ave) 
    print "1 :\t\t" + str(c1) + "\t\t" + str(100*(float(c1))/sum)[0:5] +"%"
    print "1-5 :\t\t" + str(c2)  + "\t\t" + str(100*(float(c2))/sum)[0:5] +"%"
    print "5-20 :\t\t" + str(c3)  + "\t\t" + str(100*(float(c3))/sum)[0:5]+"%"
    print "20-50 :\t\t" + str(c4) + "\t\t" + str(100*(float(c4))/sum)[0:5]+"%"
    print "50-200 :\t" + str(c5) + "\t\t"+str (100*(float(c5))/sum)[0:5]+"%"
    print "200-1000 :\t" + str(c6) + "\t\t"+str(100*(float(c6))/sum)[0:5]+"%"
    print "1000+ :\t\t" + str(c7) + "\t\t"+str(100*(float(c7))/sum)[0:5]+"%"


def count_indep_read(junction,lowerbound,index):
    dict={}
    sum=0
    for line in junction:
        if line[0:5]=='track':
            continue
        line_list=line.split('\t')
        span=line_list[index].split('_')[0].split('[')[1]
        num_indep=int(line_list[index].split('_')[1].split(']')[0])
        sum+=1
        if dict.has_key(num_indep):
            dict[num_indep]+=1
        else:
            dict[num_indep]=1
        if num_indep>lowerbound:
            print line[0:len(line)-1]
    for d in dict:
        print str(d) + ":\t" + str(dict[d]) + "\t\t" + str(100*(float(dict[d]))/sum)[0:5] +"%"

def print_indep_read(junction,lowerbound,index):
    for line in junction:
        if line[0:5]=='track':
            continue
        line_list=line.split('\t')
        span=line_list[index].split('_')[0].split('[')[1]
        num_indep=int(line_list[index].split('_')[1].split(']')[0])
        if num_indep>=lowerbound:
            print line[0:len(line)-1]


###############################################################
junction=open(filename_list[0],'r')
junction_index=file_index(filename_list[0])
if len(filename_list)==2:
    newjun=open(filename_list[1],'r')
    newjun_index=file_index(filename_list[1])


print "\n####Total####alljunction##########"
count_read(junction,0,junction_index)
if len(filename_list)==2:
    print "\n####Total####newjunction##########"
    count_read(newjun,0,newjun_index)

junction.close()
if len(filename_list)==2:
    newjun.close()
####################################################
junction=open(filename_list[0],'r')
junction_index=file_index(filename_list[0])
if len(filename_list)==2:
    newjun=open(filename_list[1],'r')

print "\n####nNR####alljunction#########"
count_indep_read(junction,lowbound_indep_read,junction_index)
if len(filename_list)==2:
    print "\n####nNR####newjunction#########"
    count_indep_read(newjun,lowbound_indep_read,newjun_index)

junction.close()
if len(filename_list)==2:
    newjun.close()
####


################################################
if len(filename_list)==2:
    newjun=open(filename_list[1],'r')
    print_indep_read(newjun,lowbound_indep_read,newjun_index)
    newjun.close()
